-- Iterate through all research, and update the costs as configured.
for index,tech in pairs(data.raw.technology) do 
	-- First, determine the tier of the research, by looking at what types of science packs is used in its research cost.
	-- Tier 1 = Any research that does not contain any green, blue or alien science packs
	-- Tier 2 = Any research that does not contain any blue or alien science packs
	-- Tier 3 = Any research that does not contain any alien science packs
	-- Tier 4 = Any research that contains alien science packs

	tier = 1;
	for Index, Value in ipairs( tech.unit.ingredients ) do
		if (tier < 2 and tech.unit.ingredients[Index][1] == "science-pack-2") then
			tier = 2;
		end
		if (tier < 3 and tech.unit.ingredients[Index][1] == "science-pack-3") then
			tier = 3;
		end
		if (tier < 4 and tech.unit.ingredients[Index][1] == "alien-science-pack") then
			tier = 4;
		end
    end
	
	
	timeMultiplier = 1.0; -- How much the time of the research is multiplied by
	countMultiplier = 1.0; -- How much the count (number of research steps) of the research is multiplied by
	costMultiplier = 2.0; -- How much the number of science packs per research-step of the research is multiplied by
	if (tier == 2) then
		timeMultiplier = 0.5;
		countMultiplier = 2.0;
		costMultiplier = 2.0;
	end
	if (tier == 3) then
		timeMultiplier = 0.5;
		countMultiplier = 3.0;
		costMultiplier = 2.0;
	end
	if (tier == 4) then
		timeMultiplier = 0.5;
		countMultiplier = 3.0;
		costMultiplier = 3.0;
	end

	local unitCopy = table.deepcopy( tech.unit )

	-- Now adjust by the modifiers for this tier
	unitCopy.count = math.max(math.floor(unitCopy.count * countMultiplier), 1);
	unitCopy.time = math.max(unitCopy.time * timeMultiplier, 1);
	
	
	for Index, Value in ipairs( unitCopy.ingredients ) do
		if Value[1] ~= "alien-science-pack" then
			Value[2] = math.floor(Value[2] * costMultiplier);
		end
    end
	
	tech.unit = unitCopy
	
end